;=======================================================	
;   PIC 16F628
; RA0 -  
; RA1 -  
; RA2 -  
; RA3 -  
; RA4 -  
; RA5 -  
; RB0 -  B 
; RB1 -  F
; RB2 -  A
; RB3 -  G
; RB4 -  E
; RB5 -  D
; RB6 -  H
; RB7 -  C
;  - , RL-F5610:  12, 9, 8, 6 - . 0 -  
;  A,B,C,D,E,F,G,H - : 11,7,4,2,1,10,5,3 . 1 -  
;=======================================================
;  
;=======================================================
		LIST p=16F628		;  
		RADIX HEX		;   
		INCLUDE "P16F628.INC"	;    
		__CONFIG	3F50H	;   4 ( = 1 ),   -  = b'11111101010000'
; Oscillator		INTRC I/O	
; Watchdog Timer	Off	
; Power Up Timer	On	
; Master Clear En.	Disabled	
; Brown Out Detec 	Enabled		
; Low Voltage Froi	Disabled	
; Data EE Read Fn	Disabled	
; Code Protect		Off			
	CBLOCK	20H			;      020
		DIG_0, DIG_1, DIG_2, DIG_3, DIG_4, DIG_5, DIG_6, DIG_7, DIG_8, DIG_9
		DIG_10, DIG_11, DIG_12, DIG_13, DIG_14
		DIG_15, DIG_16, DIG_17, DIG_18
		BRES_HI			;   24    0_
		BRES_MID		;   -//-
		BRES_LO			;   -//-
		TEMP_POZ		;
		POZ			;  
		POZ4			;  
		POZ3			;  
		POZ2			; 
		POZ1			;  
		STATUS_TEMP		;       
		W_TEMP			;      
		TEMP			;
		TEMP1
		BLINK			;
	ENDC				;     
	ORG	0x00			;    
RESET
	GOTO	SETUP			;   
	ORG	0X04			;   
;=======================================================	
;   (  0)
;=======================================================
int_handler				;     W  
		MOVWF	W_TEMP      	;     W
		MOVF	STATUS,W        ;     STATUS   W
		MOVWF	STATUS_TEMP	;     STATUS
		TSTF	BRES_MID	;    mid==0
		SKPNZ			; nz =   
		DECF	BRES_HI,f	; z,   -      (msb)
		DECFSZ	BRES_MID,f	;    ( 256)
		GOTO	INT_EXIT	; nz, ,    .
		TSTF	BRES_HI		;      
		SKPZ			; z =  ,      -  !
		GOTO	INT_EXIT	; nz, ,    .
		MOVLW	0x01		;    
		MOVWF	BRES_HI		;       
		MOVLW	0x98		;    
		MOVWF	BRES_MID	;     
		MOVLW	0x98		;   ,   
		ADDWF	BRES_LO,f	;    ,    
		SKPNC			; nc =  ,       
		INCF	BRES_MID,f	; c,    -   
		INCF	POZ, 1		;   
						
;-------------------------------------------------
;     ,      
;-------------------------------------------------
INT_EXIT
		BCF	INTCON,T0IF	;    tmr0
		MOVF	STATUS_TEMP,W  	;     STATUS
		MOVWF	STATUS          ;    STATUS,    
		SWAPF	W_TEMP,F
		SWAPF	W_TEMP,W       	;    W,    
		RETFIE			;   
		GOTO	MAIN		;    
;******************************************************************************
;  MAIN     (  )
;******************************************************************************
MAIN0
		MOVLW	0x01		;    
		MOVWF	BRES_HI		;    
		MOVLW	0x98 +1		;     (,      1)
		MOVWF	BRES_MID	;    
		MOVLW	0x98		;    
		MOVWF	BRES_LO		;    
		BCF	INTCON,T0IF	;    tmr0
		CLRF	POZ		;
		CLRF	POZ1		;
		CLRF	POZ2		;
		CLRF	POZ3		;
		CLRF	POZ4		;
MAIN		BTFSS	PORTA, 0	;   
		GOTO	MAIN0		;


		MOVF	POZ, 0		;
		BTFSS	STATUS, Z	; 
		GOTO	POZ_5		;  0
		MOVLW	0X20		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X21		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X22		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X23		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X24		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X25		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X26		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X27		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X28		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		MOVLW	0X29		;
		MOVWF	FSR		;
		BSF	INDF, 6		;
		GOTO	POZ__5		;   
POZ_5		MOVLW	0X05		;
		SUBWF	POZ, 0		;
		BTFSS	STATUS, Z	;
		GOTO	POZ__5		;
		MOVLW	0X20		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X21		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X22		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X23		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X24		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X25		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X26		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X27		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X28		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
		MOVLW	0X29		;
		MOVWF	FSR		;
		BCF	INDF, 6		;
POZ__5		MOVLW	0X0A		;
		SUBWF	POZ,0		;
		BTFSC	STATUS, Z	;
		GOTO	POZ_10		;
		MOVF	POZ,0		;
		MOVWF	POZ4		;
		CALL	INDIK		;
		GOTO	MAIN		;
POZ_10		CLRF	POZ		;
		INCF	POZ3		;
		MOVLW	0X0A		;
		SUBWF	POZ3,0		;
		BTFSC	STATUS, Z	;
		GOTO	POZ3_10		;
		CALL	INDIK		;
		GOTO	MAIN		;
POZ3_10		CLRF	POZ3		;
		INCF	POZ2		;
		MOVLW	0X0A		;
		SUBWF	POZ2,0		;
		BTFSC	STATUS, Z	;
		GOTO	POZ2_10		;
		CALL	INDIK		;
		GOTO	MAIN		;
POZ2_10		CLRF	POZ2		;
		INCF	POZ1		;
		MOVLW	0X0A		;
		SUBWF	POZ1,0		;
		BTFSC	STATUS, Z	;
		GOTO	POZ1_10		;
		CALL	INDIK		;
		GOTO	MAIN		;
POZ1_10		CLRF	POZ1		;
		CALL	INDIK		;
		GOTO	MAIN		;

;******************************************************************************
;  
;******************************************************************************		
INDIK
		MOVF	POZ4,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,1		;
		CALL	WAIT		;
		BSF	PORTA,1		;
		MOVF	POZ3,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,4		;
		CALL	WAIT		;
		BSF	PORTA,4		;
		MOVF	POZ2,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,3		;
		CALL	WAIT		;
		BSF	PORTA,3		;
		MOVF	POZ1,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,2		;
		CALL	WAIT		;
		BSF	PORTA,2		;
		BTFSC	PORTA, 5	;
		RETURN			;
		CLRF	TMR0		;
NAGAT		MOVLW	0x01		;    
		MOVWF	BRES_HI		;    
		MOVLW	0x98 +1		;     (,      1)
		MOVWF	BRES_MID	;    
		MOVLW	0x98		;    
		MOVWF	BRES_LO		;    
		BCF	INTCON,T0IF	;    tmr0
		CLRF	POZ		;
		MOVF	POZ4,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		ANDLW	0XBF		;
		MOVWF	PORTB		;
		BCF	PORTA,1		;
		CALL	WAIT		;
		BSF	PORTA,1		;
		MOVF	POZ3,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		IORLW	0X40		;
		MOVWF	PORTB		;
		BCF	PORTA,4		;
		CALL	WAIT		;
		BSF	PORTA,4		;
		MOVF	POZ2,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		ANDLW	0XBF		;
		MOVWF	PORTB		;
		BCF	PORTA,3		;
		CALL	WAIT		;
		BSF	PORTA,3		;
		MOVF	POZ1,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		ANDLW	0XBF		;
		MOVWF	PORTB		;
		BCF	PORTA,2		;
		CALL	WAIT		;
		BSF	PORTA,2		;
		BTFSS	PORTA, 5	;  
		GOTO	NAGAT			;		
		GOTO	INDIK		;
;=======================================================	
;   
;=======================================================
WAIT
		CLRW			;
W_T		ADDLW	0X01		;
		BTFSS	STATUS,Z	;
		GOTO	W_T		;
		RETURN			;
;=======================================================	
;    
;=======================================================
WAIT1		MOVF	BLINK,0		;
		SUBLW	0XFD		;
W_T1		ADDLW	0X01		;
		BTFSS	STATUS,Z	;
		GOTO	W_T1		;
		RETURN			;
;=======================================================	
;=======================================================	
;    
;=======================================================
WAIT2
		CLRW			;
		ADDWF	BLINK,0		;
W_T2		ADDLW	0X01		;
		BTFSS	STATUS,Z	;
		GOTO	W_T2		;
		RETURN			;
;=======================================================	
;=======================================================	
;   ,  
;=======================================================
SETUP		CLRF	PORTA		;  ,    
		CLRF	PORTB		;  ,    
		MOVLW	0x07		;    
		MOVWF	CMCON		;  ,    - 
		BSF	STATUS,RP0	;  1
		MOVLW	0X88		;  "10001000"   OPTION
		MOVWF	OPTION_REG	;   
		CLRF	VRCON		;    
		MOVLW	0x21		;    
		MOVWF	TRISA		; 0, A5 - ,     - 
		MOVLW	0X00		;     
		MOVWF	TRISB		;    - 
		BCF	STATUS,RP0	; 0 
		CLRF	RCSTA		;   USART
		CLRF	T2CON		;   TMR2
		CLRF	CCP1CON		;   CCP
		MOVLW	0XA0		;   B'10100000'  INTCON
		MOVWF	INTCON		;    
		MOVLW	0x01		;    
		MOVWF	BRES_HI		;    
		MOVLW	0x98 +1		;     (,      1)
		MOVWF	BRES_MID	;    
		MOVLW	0x98		;    
		MOVWF	BRES_LO		;    
		MOVLW	b'11011110'	;    
		MOVWF	PORTA		;   

;=======================================================	
; 	
;=======================================================
		MOVLW	0XB7		; 0
		MOVWF	DIG_0		;
		MOVLW	0X81		; 1
		MOVWF	DIG_1		;
		MOVLW	0X3D		; 2
		MOVWF	DIG_2		;
		MOVLW	0XAD		; 3
		MOVWF	DIG_3		;
		MOVLW	0X8B		; 4
		MOVWF	DIG_4		;
		MOVLW	0XAE		; 5
		MOVWF	DIG_5		;
		MOVLW	0XBE		; 6
		MOVWF	DIG_6		;
		MOVLW	0X85		; 7
		MOVWF	DIG_7		;
		MOVLW	0XBF		; 8
		MOVWF	DIG_8		;
		MOVLW	0XAF		; 9
		MOVWF	DIG_9		;
		MOVLW	0X12		;  
		MOVWF	DIG_10		;
		MOVLW	0X24		; +
		MOVWF	DIG_11		;
		MOVLW	0X08		; 
		MOVWF	DIG_12		;
		MOVLW	0X2C		;  
		MOVWF	DIG_13		;
		MOVLW	0X9B		;  
		MOVWF	DIG_15		;
		MOVLW	0X3E		;  
		MOVWF	DIG_16		;
		MOVLW	0X32		;  
		MOVWF	DIG_17		;
		MOVLW	0XB7		;  
		MOVWF	DIG_18		;		
;=======================================================	
; 	 
;=======================================================
		BCF	INTCON,7	;  
		MOVLW	0X0E
		MOVWF	POZ1
		MOVWF	POZ2
		MOVWF	POZ3
		MOVLW	0X01		;
		MOVWF	POZ4		;
 		CALL	WAIT4		;
		MOVLW	0X0B
		MOVWF	POZ4
		CALL	WAIT4
		MOVLW	0X0E
		MOVWF	POZ4
		MOVLW	0X0B
		MOVWF	POZ3
		CALL	WAIT4
		MOVLW	0X0E		
		MOVWF	POZ3
		MOVLW	0X0B
		MOVWF	POZ2
		CALL	WAIT4
		MOVLW	0X0E		
		MOVWF	POZ2
		MOVLW	0X0B
		MOVWF	POZ1
		CALL	WAIT4
		MOVLW	0X0A
		MOVWF	POZ1
		CALL	WAIT4
		MOVLW	0X0C
		MOVWF	POZ1
		CALL	WAIT4
		MOVLW	0X0E
		MOVWF	POZ1
		MOVLW	0X0C
		MOVWF	POZ2
		CALL	WAIT4
		MOVLW	0X0E
		MOVWF	POZ2
		MOVLW	0X0C
		MOVWF	POZ3
		CALL	WAIT4
		MOVLW	0X0E
		MOVWF	POZ3
		MOVLW	0X0C
		MOVWF	POZ4
		CALL	WAIT4
		MOVLW	0X0E
		MOVWF	POZ4
		CALL	WAIT4
		;------------
		MOVLW	0XFD
		MOVWF	TEMP1
INDIKHL		MOVLW	0X0F
		MOVWF	POZ1
		MOVLW	0X10
		MOVWF	POZ2
		MOVLW	0X11
		MOVWF	POZ3
		MOVLW	0X12
		MOVWF	POZ4
		MOVF	POZ4,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,1		;
		CALL	WAIT1		;
		BSF	PORTA,1		;
		MOVF	POZ3,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,4		;
		CALL	WAIT1		;
		BSF	PORTA,4		;
		MOVF	POZ2,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,3		;
		CALL	WAIT1		;
		BSF	PORTA,3		;
		MOVF	POZ1,0		;
		ADDLW	0X20		;
		MOVWF	FSR		;
		MOVF	INDF,0		;
		MOVWF	PORTB		;
		BCF	PORTA,2		;
		CALL	WAIT1		;
		BSF	PORTA,2		;
		;BTFSC	PORTA, 5	;
		;RETURN			;

		CALL	WAIT2		;

		;BTFSC	PORTA, 5	;
		INCF	TEMP1,1
		BTFSS	STATUS,Z
		GOTO	INDIKHL
		MOVLW	0XFD
		MOVWF	TEMP1
		INCF	BLINK,1		;
		BTFSS	STATUS,Z
		GOTO	INDIKHL
		;RETURN			;		
		BSF	INTCON,7	;  		
		GOTO	MAIN0		;    
;=======================================================	
; 	32  - 
;=======================================================
WAIT4		MOVLW	0X20
		MOVWF	TEMP
NO_END		MOVLW	0X01
		SUBWF	TEMP,1
		BTFSC	STATUS,Z
		RETURN
		CALL	INDIK
		GOTO	NO_END

		


	END